
subroutine MPI_Recv0DCH(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  character :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DCH


subroutine MPI_Recv0DL(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  logical :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DL


subroutine MPI_Recv0DI1(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*1 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DI1


subroutine MPI_Recv0DI2(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*2 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DI2


subroutine MPI_Recv0DI4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*4 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DI4


subroutine MPI_Recv0DI8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*8 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DI8


subroutine MPI_Recv0DR4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*4 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DR4


subroutine MPI_Recv0DR8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*8 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DR8


subroutine MPI_Recv0DC8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*8 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DC8


subroutine MPI_Recv0DC16(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*16 :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv0DC16


subroutine MPI_Recv1DCH(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  character, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DCH


subroutine MPI_Recv1DL(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  logical, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DL


subroutine MPI_Recv1DI1(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*1, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DI1


subroutine MPI_Recv1DI2(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*2, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DI2


subroutine MPI_Recv1DI4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*4, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DI4


subroutine MPI_Recv1DI8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*8, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DI8


subroutine MPI_Recv1DR4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*4, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DR4


subroutine MPI_Recv1DR8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*8, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DR8


subroutine MPI_Recv1DC8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*8, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DC8


subroutine MPI_Recv1DC16(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*16, dimension(*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv1DC16


subroutine MPI_Recv2DCH(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  character, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DCH


subroutine MPI_Recv2DL(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  logical, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DL


subroutine MPI_Recv2DI1(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*1, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DI1


subroutine MPI_Recv2DI2(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*2, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DI2


subroutine MPI_Recv2DI4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*4, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DI4


subroutine MPI_Recv2DI8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*8, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DI8


subroutine MPI_Recv2DR4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*4, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DR4


subroutine MPI_Recv2DR8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*8, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DR8


subroutine MPI_Recv2DC8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*8, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DC8


subroutine MPI_Recv2DC16(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*16, dimension(1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv2DC16


subroutine MPI_Recv3DCH(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  character, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DCH


subroutine MPI_Recv3DL(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  logical, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DL


subroutine MPI_Recv3DI1(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*1, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DI1


subroutine MPI_Recv3DI2(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*2, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DI2


subroutine MPI_Recv3DI4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*4, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DI4


subroutine MPI_Recv3DI8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*8, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DI8


subroutine MPI_Recv3DR4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*4, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DR4


subroutine MPI_Recv3DR8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*8, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DR8


subroutine MPI_Recv3DC8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*8, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DC8


subroutine MPI_Recv3DC16(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*16, dimension(1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv3DC16


subroutine MPI_Recv4DCH(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  character, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DCH


subroutine MPI_Recv4DL(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  logical, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DL


subroutine MPI_Recv4DI1(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*1, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DI1


subroutine MPI_Recv4DI2(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*2, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DI2


subroutine MPI_Recv4DI4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*4, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DI4


subroutine MPI_Recv4DI8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  integer*8, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DI8


subroutine MPI_Recv4DR4(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*4, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DR4


subroutine MPI_Recv4DR8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  real*8, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DR8


subroutine MPI_Recv4DC8(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*8, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DC8


subroutine MPI_Recv4DC16(buf, count, datatype, source, tag, &
        comm, status, ierr)
  include "mpif-config.h"
  complex*16, dimension(1,1,1,*) :: buf
  integer, intent(in) :: count
  integer, intent(in) :: datatype
  integer, intent(in) :: source
  integer, intent(in) :: tag
  integer, intent(in) :: comm
  integer, dimension(MPI_STATUS_SIZE), intent(inout) :: status
  integer, intent(out) :: ierr
  call MPI_Recv(buf, count, datatype, source, tag, &
        comm, status, ierr)
end subroutine MPI_Recv4DC16

